package com.winsun.controller;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.winsun.auth.core.annotion.Permission;
import com.winsun.auth.core.base.controller.BaseController;
import com.winsun.auth.core.common.model.ResponseData;
import com.winsun.bean.AuthCode;
import com.winsun.bean.KdyList;
import com.winsun.bean.MultimediaAccount;
import com.winsun.bean.RhPhone;
import com.winsun.mapper.AuthCodeMapper;
import com.winsun.mapper.RhPhoneMapper;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author: chenhaojian
 * @Date: 2021/1/14
 */
@RestController
@RequestMapping("/rhPhone")
public class RhPhoneController extends BaseController {

    private static RhPhoneMapper rhPhoneMapper;

    @Autowired
    public RhPhoneController(RhPhoneMapper rhPhoneMapper){
        RhPhoneController.rhPhoneMapper = rhPhoneMapper;
    }


    @Permission(menuname = "查询信息", value = "list", method = RequestMethod.POST)
    public Map<String,Object> dataList(@RequestParam(name = "id",required = false)String id,
                                       @RequestParam(name = "phone",required = false)String phone,
                                       @RequestParam(name = "tcName",required = false)String tcName,
                                       @RequestParam(name = "pageNo", required = false) int pageNo,
                                       @RequestParam(name = "pageSize", required = false) int pageSize
    ){
        Map<String,Object> map = new HashMap<>();
        Wrapper<RhPhone> wrapper = new EntityWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id",id);
        wrapper.eq(StringUtils.isNotBlank(phone), "phone",phone);
        wrapper.eq(StringUtils.isNotBlank(tcName), "tcName",tcName);

        Page<RhPhone> page = new Page<>(pageNo, pageSize);
        List<RhPhone> aPackage = rhPhoneMapper.selectPage(page, wrapper);
        page.setRecords(aPackage);
        map.put("page",ResponseData.success(page,"查询成功！"));
        return map;
    }

    @RequestMapping(value = "addData",method = RequestMethod.POST)
    public ResponseData<String> addData(@RequestParam(name = "phone") String phone){
        Wrapper<RhPhone> wrapper = new EntityWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(phone), "phone",phone);
        List<RhPhone> list = rhPhoneMapper.selectList(wrapper);
        if(list != null && list.size()>0){
            return ResponseData.error("融合号码已存在！");
        }
        RhPhone rhPhone = new RhPhone();
        rhPhone.setPhone(phone);
        try {
            rhPhoneMapper.insert(rhPhone);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ResponseData.success();
    }

    @RequestMapping(value = "deleteData",method = RequestMethod.POST)
    public ResponseData<String> deleteData(@RequestParam(name = "id") String id){
        if(StringUtils.isBlank(id)){
            return ResponseData.error("");
        };
        Wrapper<RhPhone> wrapper = new EntityWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id",id);
        try {
            rhPhoneMapper.delete(wrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ResponseData.success();
    }
}
